/*                                                     project Gemini 
----------------------------------------------------------------------
    Earley pR[h
      $Id: item.c,v 1.2 2002/01/03 05:41:41 Black Exp $

        Copyright (C) 2001-2002, ABE Shigeru <abe@mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#define DEBUGSW 0
#include "nlputil.h"


/* ڂ̕\ (fobOp)
----------------------------------------------------------------------
*/
Item * item_display ( Item * item )
{
    VALUE  ts;
    int    i;
    
    if( item && item->rule ) {
        ts = rb_funcall(item->rule->orig, id_typestring, 1, INT2FIX(item->dot) );
        fprintf( stderr, "(%d,%d)<Rule#{%d} %s> (b=%.2g, c=%.2g)\n",
                 item->left, item->right, item->rule->id, STR2CSTR(ts), item->beta, item->gamma );
    }
    else {
        if( !item )
            fprintf( stderr, "[NULL]\n" );
        else
            fprintf( stderr, "[Broken Item]\n" );
    }
    
    return item;
}

Item * item_display2 ( const char * header, Item * item )
{
    fprintf( stderr, header );
    return item_display( item );
}

VALUE  item_inspect  ( Item * item )
{
    VALUE  ts;
    char   buf[1024];
    char  *p = buf;
    int    i, len;
    
    if( item->rule ) {
        ts = rb_funcall( item->rule->orig, id_typestring, 1, INT2FIX(item->dot) );
        sprintf( p, "(%d,%d)[ Rule#%d: %s ] beta=%g, gamma=%g", item->left, item->right, item->rule->id, STR2CSTR(ts), item->beta, item->gamma );
    }
    else {
        sprintf( p, "[Broken Item]" );
    }
    
    return rb_str_new2( buf );
}


/* V Earley 쐬
----------------------------------------------------------------------
*/
Item *  item_reset  ( Item * item, Rule * r, int left, int right, int dot )
{
    if( !item )
        return NULL;
    
    item->rule  = r;
    item->left  = left;
    item->right = right;
    item->top   = r->lhs;
    item->dot   = dot;
    item->tag   = 0;
    
    item->beta = item->gamma = 0.0;
    
    return item;
}

Item *  item_new  ( Rule * r, int left, int right, int dot )
{
    return item_reset( ALLOC( Item ), r, left, right, dot );
}


