/*                                                     project Gemini 
----------------------------------------------------------------------
    Rꏈ [eBeB gW[
      $Id: nlputil.c,v 1.4 2002/01/15 03:08:05 Black Exp $

        Copyright (C) 2001-2002, ABE Shigeru <abe@mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#define DEFINE_BODY
#include "nlputil.h"
#include <stdarg.h>


/* W[̃o[W
----------------------------------------------------------------------
*/
static VALUE nlputil_Version ( VALUE klass )
{
    const char *  mes = "nlputil extention module   ver 1.0";
    
    return rb_str_new2( mes );
}


/*   gW[̏|Cg
----------------------------------------------------------------------
*/
void Init_nlputil ( void )
{
    /* KvȃIuWFNg𓾂
    ---------------------------------------- */
    rb_eNLPException = rb_const_get( rb_cObject, rb_intern( "NLPException" ) );
    if( NIL_P( rb_eNLPException ) ) {
        rb_raise( rb_eRuntimeError, "class `NLPException' is not defined." );
    }
    rb_mExt = rb_define_module( "Ext" );
    rb_define_singleton_methods(
        rb_mExt, 
        
        "Version"			, nlputil_Version, 0,
        
        NULL );
    
    /* W[̏ (邱)
    ---------------------------------------- */
    init_grammar();
    init_stolcke();
    init_chart();
    init_itemset();
    init_sgraph();
    init_gem();
    init_strparse();
    
    /* ʎq ID 𓾂
    ---------------------------------------- */
    id_at    = rb_intern( "at" );
    id_id    = rb_intern( "id" );
    id_lhs   = rb_intern( "lhs" );
    id_rhs   = rb_intern( "rhs" );
    id_to_r  = rb_intern( "to_r" );
    id_size  = rb_intern( "size" );
    id_last  = rb_intern( "last" );
    id_first = rb_intern( "first" );
    id_range = rb_intern( "range" );
    
    id_length     = rb_intern( "length" );
    id_catlist    = rb_intern( "catlist" );
    id_compiled_p = rb_intern( "compiled?" );
    id_typestring = rb_intern( "typestring" );
}


/*   Ruby f[^p[eBeB
----------------------------------------------------------------------
*/
int ru_is_instance_of ( VALUE obj, VALUE klass )
{
    if( !rb_obj_is_instance_of( obj, klass ) )
        rb_raise( rb_eNLPException, "Argument type is not %s.", STR2CSTR(rb_String(rb_funcall(klass, rb_intern("class"),0))) );
    
    return 1;
}


/*   fobOp[eBeB
----------------------------------------------------------------------
*/
int errp ( const char * format, ... )
{
    va_list ap;
    
    va_start( ap, format );
    return vfprintf( stderr, format, ap );
}

int defp ( const char * format, ... )
{
    va_list ap;
    
    va_start( ap, format );
    return vfprintf( stdout, format, ap );
}


