/*                                                     project Gemini 
----------------------------------------------------------------------
    Rꏈ [eBeB gW[
      $Id: nlputil.h,v 1.15 2002/02/08 04:43:09 Black Exp $

        Copyright (C) 2001-2002, ABE Shigeru <abe@mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#ifndef _NLPUTIL_20011111Sun_090920_
#define _NLPUTIL_20011111Sun_090920_

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>

#include "rubytool.h"
#include "matrix.h"


/*   fobOR[h
----------------------------------------------------------------------
*/
#if DEBUGSW

#undef  Dputs
#undef  Dprintf
#undef  Dcom

#define Dputs(STR) fputs( STR, stderr )
#define Dprintf(STR,V) fprintf( stderr, STR, V )
#define Dcom(COM) (COM)

#else

#define Dputs(STR)
#define Dprintf(STR,V)
#define Dcom(COM)

#endif

int errp ( const char * format, ... );
int defp ( const char * format, ... );



/*   mp[^Ȃǂ̎l^
----------------------------------------------------------------------
*/
typedef  double  real_t;



/*   K
----------------------------------------------------------------------
*/
struct  tagRule  {
    VALUE  orig;
    
    int   id;
    int   lhs;
    int  *rhs; /* [0,rhslen) */
    int   rhslen;
    
    struct tagRule  *next_lc;
    struct tagRule  *next_lhs;
};
typedef  struct tagRule  Rule;

typedef Rule * RulePtr;
typedef Rule * Ruleptr;



/*   @
----------------------------------------------------------------------
    hash_lhs --> nonterm
    hash_lc  --> symbol
*/
struct  tagGrammar  {
    VALUE  object_cache; /* GCp */
    VALUE  orig;
    
    int    size_rule;
    Rule  *rules;  /* [0,size_rule) */
    
    int       size_lhshash; /*= nonterm count */
    RulePtr  *hash_lhs;  /* [0,size_lhshash) */
    
    int       size_lchash; /*= symbol count */
    RulePtr  *hash_lc;  /* [0,size_lchash) */
    
    /* ǗpȂ̂ő삵ȂƁ */
    int  *buffer_rhs;
    int   buffer_rhs_size;
    /* ǗpȂ̂ő삵ȂƁ */
};
typedef  struct tagGrammar  Grammar;



/*   Earley 
----------------------------------------------------------------------
*/
struct  tagItem
{
    /* \͗pf[^ */
    Rule  *rule;
    int  top;
    int  dot;
    int  left, right;
    
    /* mp[^ (beta=O, gamma=) */
    double  beta, gamma;
    
    /* p^O */
    int  tag;
    struct tagItem  *data; /* g͎R */
    
    /* nbVpN */
    struct tagItem  *next_comp;
    struct tagItem  *next_rwait;
    struct tagItem  *next_lwait;
    struct tagItem  *next_dot;
};
typedef  struct tagItem  Item;

typedef  Item *  Itemptr;
typedef  Item *  ItemList;
typedef  Itemptr *  ItemptrList;

#define TAG_Used_in_Parse (0x10)
#define TAG_Visited       (0x20)
#define TAG_StartItem     (0x40)



/*   `[g\
----------------------------------------------------------------------
    hash_dot
      H邱Ƃ̂ł Item ̓`[g̑S Item ɂȂB

    hash_...
      ɏꂽ [`] ́Az̓YӖB
      [left][right] Ȃ΁AʒuƉEʒuYɂƂ邱ƂB
*/
struct  tagChart
{
    VALUE  object_cache; /* GC }[NpXg */
    
    Grammar  *grammar; /* `[g쐬Ɏg@IuWFNg */
    VALUE     poslist; /* `[g쐬Ɏg PoS Xg */
    
    /* f[^ʂ̃LbV */
    int  len; /* ({̒)+1 ɂȂĂ̂Œ */
    int  symbol;
    
    /* NhXg̊Jnڃe[u */
    Itemptr  *hash_comp;  /*           : [left * len + right] */
    Itemptr  *hash_rwait; /* E[̑ҋ@: [category * len + right (<=length)] */
    Itemptr  *hash_lwait; /* [̑ҋ@: [category * len + left (<=length)] */
    Itemptr  *hash_dot;   /*   hbgʒu: [dot (<=length)] */
    
    /* v */
    int  count_item;
    int  count_deleted;
    int  count_cancelled;
};
typedef  struct tagChart  Chart;

#define chart_dot(CHART,DOT) ((CHART)->hash_dot[(DOT)])
#define chart_comp(CHART,LEFT,RIGHT) ((CHART)->hash_comp[(LEFT)*(CHART)->len + (RIGHT)])
#define chart_rwait(CHART,CAT,POS) ((CHART)->hash_rwait[(CAT)*(CHART)->len + (POS)])
#define chart_lwait(CHART,CAT,POS) ((CHART)->hash_lwait[(CAT)*(CHART)->len + (POS)])



/*   ͌
----------------------------------------------------------------------
*/
struct  tagParsedItem
{
    VALUE  rule;
    int    top, left, right;
    void  *data;  /* [`ɂėprقȂ */
    
    /* qƂȂ鍀̃Xg */
    struct tagParsedItem *  *child;
    int  child_len;
    
    struct tagParsedItem *  next_item; /* left,right,top ւ̃N */
    struct tagParsedItem *  next_hash; /* left,right ւ̃N */
};
typedef  struct tagParsedItem  ParsedItem;

typedef  ParsedItem *  ParsedItemptr;


struct  tagItemSet
{
    VALUE  obj_cache; /* GC p̃IuWFNgLbV */
    int    sent_len;  /* ۂ̒+1 */
    
    ParsedItem  *itembuf; /* jƂȂ銮̃Xg (ׂĂ̍߂) */
    int  itembuf_size;
    
    ParsedItemptr  *childbuf; /* qEJnp̃obt@ */
    int  childbuf_size;
    
    ParsedItemptr  *headbuf; /* left,right,topdȂ悤ɕׂitembuf (next_itemÑgbv) */
    int  headbuf_size;
    
    ParsedItem  *start; /* Jn */
    VALUE  rulemap;
};
typedef  struct tagItemSet  ItemSet;



/*  PL[
----------------------------------------------------------------------
 - i[鍀ׂ͂ăRs[B
   `[g̍Ƃ͕ʂ̂̂ɂȂB
*/
struct  tagSimpleQueue
{
    Item  *buffer;
    int    capacity;
    int    size;
};
typedef  struct tagSimpleQueue  SimpleQueue;



/*  tL[
----------------------------------------------------------------------
    
     - left   :   
     - ntorder:    (\؂ŏɗ̂)
    pop  unshift gƂ left ő, ntorder ő (\؏ŉ) oƂłB
    shift  push gƂŋtɂȂB
*/
struct  tagPrioritizedQueueUnit
{
    Itemptr  *ptr;
    int  len;
    int  cap;
};
typedef  struct tagPrioritizedQueueUnit  PrioritizedQueueUnit;

struct  tagPrioritizedQueue
{
    PrioritizedQueueUnit  *ptr;
    int  head, tail;
    int  len;
    int  cap;
};
typedef  struct tagPrioritizedQueue  PrioritizedQueue;



/*   Stolcke p[U
----------------------------------------------------------------------
*/
struct tagGenericStolcke
{
    VALUE  object_cache; /* GC }[NpXg */
    
    Grammar  *grammar; /* gp镶@IuWFNg */
    VALUE     chart_ary; /* `[g̕ۊǃXg */
    
    double  *probtbl;  /* Km */
    double  *xnumtbl;  /* ғKp (eXpect NUMber) p̎gႤ]IƂ˂܂Ȃ[ */
    double  *xnumbuf;  /* ғKp񐔂̈ꎞobt@ */
    
    int  **first_tbl;  /* FIRST e[u */
    
    int  pruning_flag;  /* }tO */
    int  loopcount;     /* [v */
    
    /* Gpobt@ */
    int  *predtbl;  /* Prediction ꂽL̃`FbNp */
};
typedef  struct tagGenericStolcke  GenericStolcke;

struct tagMatrixStolcke
{
    GenericStolcke  gen;
    Matrix  ru; /* R_u: ru[w][c] = Pu(wc) */
};
typedef  struct tagMatrixStolcke  MatrixStolcke;



/*   xOt
----------------------------------------------------------------------
*/
struct tagSG_Graph;

struct tagSG_Node
{
    union {
        struct Indirect {
            int  type; /* type=0: f[^ */
            union  {
                int  sw;  /* type=1: XCb`IuWFNg */
                struct tagSG_Graph  *graph;   /* type=2: Ot */
            } data;
        } ind; /* ԐڎQƔ */
        struct Direct {
            real_t  *i_ptr; /* Inside vZ */
            real_t  *o_ptr, *o_inside; /* Outside vZ */
        } dir; /* ڎQƔ */
    } d;
};
typedef struct tagSG_Node SG_Node;

struct tagSG_Path
{
    SG_Node  *nodeary;
    int       nodelen;
    real_t    inside;
};
typedef struct tagSG_Path SG_Path;

struct tagSG_Graph
{
    SG_Path  *pathary;
    int       pathlen;
    real_t    inside, outside;
    
    void  *ext; /* ǉf[^ */
};
typedef struct tagSG_Graph SG_Graph;

struct tagSupportGraph
{
    /* f[^obt@ */
    int        size_graph;
    SG_Graph  *buffer_graph;
    
    int        size_path;
    SG_Path   *buffer_path;
    
    int        size_node;
    SG_Node   *buffer_node;
    
    /* ǉf[^p̃obt@ */
    void  *ext_graph;
    
    /* Zpf[^ (GraphicalEM Ȃǂɓo^ꂽƂɏ) */
    real_t  *probtbl;
    real_t  *xnumtbl;
    int      size_rule;
};
typedef struct tagSupportGraph SupportGraph;


/*   OtBJ EM
----------------------------------------------------------------------
*/
struct tagGraphicalEM
{
    VALUE  obj_cache; /* GC p̃IuWFNgLbV */
    
    Grammar  *grammar; /* XV镶@IuWFNg */
    VALUE     sgary;   /* gpxOt̃Xg */

    int  loopcount;
    
    real_t  *probtbl;
    real_t  *xnumtbl;
};
typedef  struct tagGraphicalEM  GraphicalEM;


/*   O[oϐ
----------------------------------------------------------------------
*/
#undef EXTERN
#ifdef DEFINE_BODY
#define EXTERN
#else
#define EXTERN extern
#endif
EXTERN VALUE rb_eNLPException;
EXTERN VALUE rb_mExt;
EXTERN VALUE rb_cGrammar;
EXTERN VALUE rb_mStolckeParser;
EXTERN VALUE rb_cStolckeParser_matrix;
EXTERN VALUE rb_cChart;
EXTERN VALUE rb_cItem;
EXTERN VALUE rb_cItemSet;
EXTERN VALUE rb_cSupportGraph;
EXTERN VALUE rb_cGraphicalEM;

EXTERN ID id_id;
EXTERN ID id_at;
EXTERN ID id_lhs;
EXTERN ID id_rhs;
EXTERN ID id_size;
EXTERN ID id_to_r;
EXTERN ID id_last;
EXTERN ID id_first;
EXTERN ID id_range;
EXTERN ID id_length;
EXTERN ID id_catlist;
EXTERN ID id_compiled_p;
EXTERN ID id_typestring;



/*   vg^Cv錾
----------------------------------------------------------------------
*/

/* grammar.c */
VALUE cfg_get_catname ( Grammar * g, int id );
void first_tbl_free ( int * *ptr );
int ** first_tbl_get ( Grammar * gram );
void init_grammar ( void );


/* stolcke.c */
void init_stolcke ( void );

GenericStolcke * stolcke_generic_new ( GenericStolcke * stolcke );
GenericStolcke * stolcke_generic_initialize ( GenericStolcke * stolcke, Grammar * grammar );
void stolcke_generic_delete ( GenericStolcke * stolcke );
void stolcke_generic_clear_predtbl ( GenericStolcke * stolcke );
int stolcke_reachable_p ( GenericStolcke * stolcke, int keycat, VALUE cat );
VALUE stolcke_solve_poslist_nest ( VALUE pos, RArrayPtr posary_list );
void stolcke_prediction ( GenericStolcke * stolcke, Chart * chart, int position, VALUE prefetch );
void stolcke_prediction_toplevel ( GenericStolcke * stolcke, RArrayPtr posary_list, Chart * chart, VALUE prefetch );
void stolcke_pruning ( Chart * chart );


/* item.c */
Item * item_display ( Item * item );
Item * item_display2 ( const char * header, Item * item );
VALUE item_inspect ( Item * item );
Item * item_reset ( Item * item, RulePtr r, int left, int right, int dot );
Item * item_new ( RulePtr r, int left, int right, int dot );

/* chart.c */
void chart_free_internal ( Chart * chart );
VALUE chart_new ( Grammar * grammar, VALUE poslist );
Chart * chart_init ( Chart * chart, Grammar * grammar, VALUE poslist );
void chart_additem ( Chart * chart, Item * item );
Item * chart_find ( Chart * chart, Item const * item );
Chart * chart_merge ( Chart * dest, Chart * src, int left, int right );
Chart * chart_move_parentitem ( Chart * chart, Chart * parentchart, int left );
Chart * chart_pruning ( Chart * chart );
void chart_reset_probability ( Chart * chart, GenericStolcke * stolcke );
void chart_debug_display ( Chart * chart );
double chart_likelihood_internal ( Chart * chart );

/* queue.c */
SimpleQueue * squeue_new ( void );
SimpleQueue * squeue_init ( SimpleQueue * sq );
SimpleQueue * squeue_clear ( SimpleQueue * sq );
void squeue_free ( SimpleQueue * sq );
SimpleQueue * squeue_push ( SimpleQueue * sq, Item * item );
int squeue_is_empty ( SimpleQueue * sq );
Item * squeue_shift ( SimpleQueue * sq );
Item * squeue_find ( SimpleQueue * sq, Item * item );
void squeue_inspect ( SimpleQueue * sq );

PrioritizedQueue * pqueue_new ( PrioritizedQueue * queue );
PrioritizedQueue * pqueue_init ( PrioritizedQueue * pq, int length );
PrioritizedQueue * pqueue_clear ( PrioritizedQueue * pq );
void pqueue_free ( PrioritizedQueue * pq );
Item * pqueue_pop ( PrioritizedQueue * q );
Item * pqueue_push ( PrioritizedQueue * q, Item * item, int * order );
Item * pqueue_shift ( PrioritizedQueue * q );
Item * pqueue_unshift ( PrioritizedQueue * q, Item * item, int * order );
Item * pqueue_find ( PrioritizedQueue * q, Item * item, int * order );
Item * pqueue_is_include ( PrioritizedQueue * q, Item * item );
void pqueue_inspect ( PrioritizedQueue * q );


/* itemset.c */
void init_itemset ( void );

/* sgraph.c */
void init_sgraph ( void );
SupportGraph * sgraph_compile ( SupportGraph * sg, int rulesize, real_t * probtbl, real_t * xnumtbl );
SupportGraph * sgraph_alloc_ext ( SupportGraph * sg, int unit_size );

/* strparse.c */
void init_strparse ( void );


/*   Ruby f[^p[eBeB
----------------------------------------------------------------------
*/
#define ru_at(ary,pos) rb_funcall(ary,id_at,1,INT2FIX(pos))
#define ru_id(obj) NUM2INT(rb_funcall(obj,id_id,0))
#define ru_size(obj) NUM2INT(rb_funcall(obj,id_size,0))
#define ru_length(obj) NUM2INT(rb_funcall(obj,id_length,0))
#define ru_first(obj) rb_funcall(obj,id_first,0)
#define ru_last(obj) rb_funcall(obj,id_last,0)
#define ru_rhs(obj) rb_funcall(obj,id_rhs,0)
#define ru_lhs(obj) rb_funcall(obj,id_lhs,0)
#define ru_compiled_p(obj) RTEST(rb_funcall(obj,id_compiled_p,0))

int ru_is_instance_of ( VALUE obj, VALUE klass );



#endif /* _NLPUTIL_20011111Sun_090920_ */
